--- chg-zd-mtx.distrib	Wed Nov 14 23:35:04 2001
+++ chg-zd-mtx	Fri Dec  7 16:52:42 2001
@@ -1,4 +1,4 @@
-#!/bin/sh 
+#!/bin/sh
 #
 # Exit Status:
 # 0 Alles Ok
@@ -72,6 +72,19 @@
 sbindir=${exec_prefix}/sbin
 libexecdir=/usr/lib/amanda
 
+# Check for a running script.  Can not run two scripts at the same time.  It
+# will create race conditions. -- Chad Walstrom <chad@ima.umn.edu>
+pidfile=/var/run/chg-zd-mtx.pid
+if test -f /var/run/chg-zd-mtx.pid ; then
+    oldpid=$(cat $pidfile)
+    if test -f /proc/$oldpid ; then
+	    # could use 'ps -C chg-zd-mtx -pid=' and compare to $oldpid
+	    echo "chg-zd-mtx process is already running at PID $oldpid" 1>&2
+	    exit 2;
+    fi
+    echo $$ > $pidfile
+fi
+
 # try to hit all the possibilities here
 PATH=$sbindir:$libexecdir:/usr/bin:/bin:/usr/sbin:/sbin:/usr/ucb:/usr/local/bin
 export PATH
@@ -164,9 +177,11 @@
 		fi
 		$MTX unload $usedslot $drivenum 2>/dev/null
 		echo "0 $tape"
+		rm $pidfile
 		exit 0
 	else
 		echo "0 Drive was not loaded"
+		rm $pidfile
 		exit 1
 	fi
 }
@@ -177,9 +192,11 @@
 	result=`$MTX load $firstslot $drivenum 2>&1`
 	if [ $? -eq 0 ]; then
 		echo "1 $tape"
+		rm $pidfile
 		exit 0
 	else
 		echo "1 $result"
+		rm $pidfile
 		exit 1
 	fi
 }
@@ -196,6 +213,7 @@
 				loadslot=$firstslot
 			else 
 				echo "$usedslot $tape"
+				rm $pidfile
 				exit 0
 			fi
 			;;
@@ -241,6 +259,7 @@
 	# Is this already the current slot?
 	if [ $loadslot = $usedslot ]; then
 		echo "$usedslot $tape"
+		rm $pidfile
 		exit 0
 	fi
 
@@ -321,6 +340,7 @@
 		$MT $MTF $tape rewind
 		echo "$loadslot" > $slotfile
 		echo "$loadslot $tape"
+		rm $pidfile
 		exit 0
 	fi
 }
@@ -338,6 +358,7 @@
                 else
                         echo "$usedslot $lastslot 1 1"
                 fi
+		rm $pidfile
                 exit 0
         else
                 if [ $usedslot -lt 0 ]; then
@@ -345,6 +366,7 @@
                 else
                         echo "$usedslot $lastslot 1"
                 fi
+		rm $pidfile
                 exit 0
         fi
 }
@@ -385,6 +407,7 @@
                 fi
                 ;;
         esac
+	rm $pidfile
         exit 0
 }
 
@@ -413,6 +436,7 @@
                         `cat $DBGFILE | $mailer -s "Error with barcode reader on \`date\`" $email`
                         `killall amtape`
                 fi
+		rm $pidfile
                 exit 0
         esac
 }
